# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4
from __future__ import division, with_statement
import os

from django.db import models
from django.conf import settings
from ox.utils import json


class Page(models.Model):
    created = models.DateTimeField(auto_now_add=True)
    modified = models.DateTimeField(auto_now=True)
    name = models.CharField(max_length=1024, unique=True)
    body = models.TextField(blank=True)

    def __unicode__(self):
        return self.name


class SiteSettings(models.Model):
    key = models.CharField(max_length=1024, unique=True)
    value = models.TextField(blank=True)

    def __unicode__(self):
        return self.key

with open(settings.SITE_CONFIG) as f:
    config = json.load(f)
    config['site']['id'] = settings.SITEID
    config['site']['name'] = settings.SITENAME
    config['site']['sectionName'] = settings.SITENAME
    config['site']['url'] = settings.URL

    config['keys'] = {}
    for key in config['itemKeys']:
        config['keys'][key['id']] = key

def site_config():
    return config.copy()
